> ## Documentation Index
> Fetch the complete documentation index at: https://docs.prophecy.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Microsoft OneDrive connection properties API

> Properties required to create and update OneDrive connections

Properties for Microsoft OneDrive connections are specified in the `properties` object when creating or updating a connection. All properties are nested within the connection request body.

<Note>
  Consider the following when creating a OneDrive connection:

  * When using the [create connection API](/api-reference/connections/add-connection-to-fabric), the secret must be stored in Prophecy before creating the connection.

  * You cannot create a OneDrive connection using the [create fabric API](/api-reference/fabrics/create-a-new-fabric), unless the required secrets are already created in Prophecy. This is because this connection type requires more than one secret, and the create fabric API only supports creating one secret at a time.
</Note>

## Properties

<ParamField body="tenantId" type="string" required>
  Azure Active Directory tenant ID.
</ParamField>

<ParamField body="clientId" type="string" required>
  Azure Active Directory application (client) ID.
</ParamField>

<ParamField body="clientSecret" type="object" required>
  Reference to a Prophecy secret containing the Azure client secret.

  <Expandable title="clientSecret properties">
    <ParamField body="clientSecret.kind" type="string" required>
      Secret kind. Must be `prophecy`.
    </ParamField>

    <ParamField body="clientSecret.subKind" type="string" required>
      Secret sub-type. Must be `text` for client secrets.
    </ParamField>

    <ParamField body="clientSecret.type" type="string" required>
      Type of reference. Must be `secret`.
    </ParamField>

    <ParamField body="clientSecret.properties" type="object" required>
      Properties identifying the secret by ID and name.
    </ParamField>

    <ParamField body="clientSecret.properties.id" type="string" required>
      The ID of the secret stored in Prophecy. Find the ID using the [List secrets per fabric
      API](/api-reference/secrets/list-secrets-per-fabric).
    </ParamField>

    <ParamField body="clientSecret.properties.name" type="string" required>
      The name of the secret stored in Prophecy.
    </ParamField>
  </Expandable>
</ParamField>

<ParamField body="userName" type="object" required>
  Reference to a Prophecy secret containing the OneDrive username.

  <Expandable title="userName properties">
    <ParamField body="userName.kind" type="string" required>
      Secret kind. Must be `prophecy`.
    </ParamField>

    <ParamField body="userName.subKind" type="string" required>
      Secret sub-type. Must be `text` for usernames.
    </ParamField>

    <ParamField body="userName.type" type="string" required>
      Type of reference. Must be `secret`.
    </ParamField>

    <ParamField body="userName.properties" type="object" required>
      Properties identifying the secret by ID and name.
    </ParamField>

    <ParamField body="userName.properties.id" type="string" required>
      The ID of the secret stored in Prophecy. Find the ID using the [List secrets per fabric
      API](/api-reference/secrets/list-secrets-per-fabric).
    </ParamField>

    <ParamField body="userName.properties.name" type="string" required>
      The name of the secret stored in Prophecy.
    </ParamField>
  </Expandable>
</ParamField>
